//filename game.c

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include "game.h"

char gameState = INIT;
int gameloop(void) {
    cmMov *zmove;
    //variables for INIT menu
    //unsigned int *texhandle;
    const SDL_VideoInfo* info = NULL;
    int width = 0;
    int height = 0;
    int bpp = 0;
    int flags = 0;
    //variables for MENU menu
    char fonts[20] = "fontsa.jpg";
    //SDLKey ownkeysym[4];
    //variable inits for movement controls
    switch (gameState) {
        case INIT:
        if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) {
            fprintf( stderr, "Video initialization failed: %s\n", SDL_GetError() );
            //gameState=SHUTDOWN;
        }
        SDL_ShowCursor(0);
        /* Let's get some video information. */
        info = SDL_GetVideoInfo( );
        if( !info ) {
            /* This should probably never happen. */
            fprintf( stderr, "Video query failed: %s\n",
            SDL_GetError( ) );
            h3dexit( 1 );
        }
        width = 1440;
        height = 900; //later can choose in the menu
        bpp = info->vfmt->BitsPerPixel;
        SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
        SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
        SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
        SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
        SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
        flags = SDL_OPENGL | SDL_FULLSCREEN;
        if( SDL_SetVideoMode( width, height, bpp, flags ) ==0 ) {
            fprintf( stderr, "Video mode set failed : %s\n", SDL_GetError() );
            //gameState=SHUTDOWN;
        }
        setup_opengl( width, height );
        SDL_GL_SwapBuffers();	
        loadTextures( fonts, 30); //load the fonts into texture buffer position 1
        gameState=MENU;
        return 1; //return 1 if to continue running or 0 to stop			
        break;

        case INTRO:
        break;
        case MENU:
        //setup keys
        draw_screen (0 );
        SDL_GL_SwapBuffers ( );
        gameState=handle_key_down(0,1);
        //gameState=GAME;
        break;

        case GAME:
        while (1) {
            zmove=processkeyboard_events();
            
            draw_screen( zmove );
            SDL_GL_SwapBuffers( );
        }
        return 0; //return 0 to stop running or 1 to continue
        break;

        case SHUTDOWN:
        break;
        default:
        fprintf(stderr, "Bad game state");
        break;
    }
}



void h3dexit( int code ) {
    // have to call a function in textureCode.c to do this --> glDeleteTextures ( 1, &onetexturehandle ) ;
    SDL_Quit( );
    exit( code );
}
void setup_opengl( int width, int height ) {
    float ratio = (float) width / (float) height;
    /* Our shading model--Gouraud (smooth). */
    //vars to setup lighting
    float white[ 4 ]= {1.0f, 1.0f, 1.0f,1.0f};
    float red[ 4 ] = {1.0f, 0.0f, 0.0f, 1.0f};
    float yellow[ 4 ]= {1.0f, 1.0f, 0.0f, 1.0f};
    float black[ 4 ]= {0.0f, 0.0f, 0.0f, 1.0f};
    float blue[4]= {0.04f,0.02f,0.6f,1.0f};
    float dim_white[3]= {0.3f, 0.3f, 0.3f};
    glShadeModel( GL_SMOOTH );
    /* Culling. */
    glCullFace( GL_BACK );
    glFrontFace( GL_CCW );
    glEnable( GL_CULL_FACE );
    //glEnable( GL_TEXTURE_2D );
    glEnable( GL_DEPTH_TEST ); //usually want to disable when rendering things that are in front of everything else
    
    glEnableClientState (GL_NORMAL_ARRAY );
    glEnableClientState (GL_COLOR_ARRAY );



    glEnableClientState (GL_TEXTURE_COORD_ARRAY );
    glEnableClientState (GL_VERTEX_ARRAY );
    /* Set the clear color. */
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
    // Enables Clearing Of The Depth Buffer
    glClearDepth(1.0);
    // The Type Of Depth Test To Do
    glDepthFunc(GL_LEQUAL);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glShadeModel(GL_SMOOTH);
    
//setup light source
    //glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, yellow );
    //glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE, yellow );

    glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, black );
    glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, white );
    glMaterialf( GL_FRONT_AND_BACK, GL_SHININESS, 4.0f );
    glEnable( GL_COLOR_MATERIAL );
    glColorMaterial( GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE );
    //glLightfv( GL_LIGHT0, GL_POSITION, pos ); //first parm sets up which light LIGHT), LIGHT 1 etc, second which attribute
    glLightfv( GL_LIGHT0, GL_AMBIENT, dim_white);
    glLightfv( GL_LIGHT0, GL_DIFFUSE, white);
    glLightfv( GL_LIGHT0, GL_SPECULAR, white);
    
	glEnable( GL_LIGHTING );
    glEnable( GL_LIGHT0 );

    /* Setup our viewport. */
    glViewport( 0, 0, width, height );
    /*

    * Change to the projection matrix and set
    * viewing volume.
    */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );
    gluPerspective( 60.0, ratio, 1.0, 1024.0 );
}













