//modelInit.c
//Arek Stankiewicz
//initialize values for models
//load the models

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include "game.h"
void calculateExtremities(int *modeltoCalculate) {
    //to find centre of model for collision detection
    model *modeltoCalc;
    int g,i, vertices;
    GLfloat radiustemp[3], maxRadius;
    modeltoCalc=modeltoCalculate;
	vertices = modeltoCalc->vertices;
		
    modeltoCalc->extremx[0]=modeltoCalc->modelVertices[0]; modeltoCalc->extremx[1]=modeltoCalc->modelVertices[0];
    for (i=0;i<(vertices*3);i+=3) {
        if (modeltoCalc->extremx[0]>modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremx[0]=modeltoCalc->modelVertices[i];
        }
        if (modeltoCalc->extremx[1]<modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremx[1]=modeltoCalc->modelVertices[i];
        }
    }
    modeltoCalc->extremy[0]=modeltoCalc->modelVertices[1]; modeltoCalc->extremy[1]=modeltoCalc->modelVertices[1];
    for (i=1;i<(vertices*3);i+=3) {
        if (modeltoCalc->extremy[0]>modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremy[0]=modeltoCalc->modelVertices[i];
        }
        if (modeltoCalc->extremy[1]<modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremy[1]=modeltoCalc->modelVertices[i];
        }
    }
    modeltoCalc->extremz[0]=modeltoCalc->modelVertices[2]; modeltoCalc->extremz[1]=modeltoCalc->modelVertices[2];
    for (i=2;i<(vertices*3);i+=3) {
        if (modeltoCalc->extremz[0]>modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremz[0]=modeltoCalc->modelVertices[i];
        }
        if (modeltoCalc->extremz[1]<modeltoCalc->modelVertices[i]) {
            modeltoCalc->extremz[1]=modeltoCalc->modelVertices[i];
        }
    }
    //the radius will be an average of the x, y and z values
    radiustemp[0] = modeltoCalc->extremx[1] - modeltoCalc->extremx[0] ;
    maxRadius = radiustemp[0];
    radiustemp[1] = modeltoCalc->extremy[1] - modeltoCalc->extremy[0] ;
    if (radiustemp[1] > maxRadius ) maxRadius = radiustemp[1];

    radiustemp[2] = modeltoCalc->extremz[1] - modeltoCalc->extremz[0] ;
    if (radiustemp[2] > maxRadius ) maxRadius = radiustemp[2];

	

    //modeltoCalc->radius = ((radiustemp[0] + radiustemp[1] + radiustemp[2]) / 3) / 2;
    modeltoCalc->radius = maxRadius/2;
    //printf("\n Radius is %f\n", modeltoCalc->radius);
    modeltoCalc->CentrePos[0] = ( modeltoCalc->extremx[0] + modeltoCalc->extremx[1] ) / 2;
    modeltoCalc->CentrePos[1] = ( modeltoCalc->extremy[0] + modeltoCalc->extremy[1] ) / 2;
    modeltoCalc->CentrePos[2] = ( modeltoCalc->extremz[0] + modeltoCalc->extremz[1] ) / 2;
    printf("\nCentrePos xyz is %f, %f, %f\n",modeltoCalc->CentrePos[0],modeltoCalc->CentrePos[1],modeltoCalc->CentrePos[2]);
    
}





int loadModel (int *modelTL, char filenam[] , float ScalingFactor) {
    FILE *fileptr;
    char space[2], Filedesc[80], filetype[] = "stl";
	char data[300], xdata[300], doing[1], nullstring[30],nullstring2[30],textureFilename[30], fnn[30];
	char objName[30];
	static int startFrame,endFrame, currframe=1, readinframe = 0;
	int i, j, k, v, n, nf, vertPos = 0, texPos = 0, line, f, g, donothing;
    model *modelToload;
    int triangles=0, indices = 0 ;
    long int facets;
    float vertice[9], normal[3];   
    float ab[3], ac[3], dst[3], len, normala[3], normalb[3], normalc[3];
  	int faces,i1,i2,i3, noVerts, noFaces, loadTexture = 0;
	//int ax, ay, az,  foundCore, core, e1, e2, foundPos1, foundPos2, fp1;
	//int founde1, founde2,stripArray[NUM_FACE_VERTICES+2], numFound, e1at, e2at, coreat;
	float f1,f2,f3, n1, n2, n3;
	GLfloat tempVerts[3 * NUM_FACE_VERTICES], tempNorms[3 * NUM_FACE_VERTICES],uv[6];
	strcpy(fnn,filenam);
	printf("\n%s filename in load model top",fnn);
	
	//determine filetype
   	for(i = 0; filenam[i] != NULL; i++);
	for(j = 0; j < 3; j++){ //basically grab te last 3 characters of the filename (j3d or stl)
			filetype[j] = filenam[i-3+j];
	}
			
  
    // variables to setup normals
    modelToload=modelTL;
    
	printf("\n%s filename in load model",filenam);
    fileptr=fopen(filenam, "r");
    if( fileptr == NULL ) {
        printf("\nError opening file, does the file %s exist?\n", filenam);
    }
    else {

        //printf("\nFile exists! %s\n", filenam);
    }
	if (filetype[0] == 's' ) { // for STL filetype
		fread(&Filedesc, 1, 80, fileptr);
		fread(&facets, 4, 1, fileptr);
		printf("\n%ld\n", facets);
		modelToload->vertices = facets * 3;
		//print the results
		for (i=0;i<=(3*facets);i++) {
			modelToload->indices[triangles]=triangles; //add indicies, for how many triangles there are
			triangles++;
		}

		n = 0;
		v = 0;
	
		for (i=0;i<=facets;i++){ 

			fread(&normal, 4, 3, fileptr);
			for (j=0;j<3;j++) {
				modelToload->face_normals[n] = normal[j];
				n++;
			}
			fread(&vertice, 4, 9, fileptr);
			for (j=0;j<9;j++) {
				modelToload->modelVertices[v] = vertice[j];
				v++;
			}

			fread(&space, 2, 1, fileptr);
		}
			v = 0;
			n = 0;
			

		for (i=0;i<=facets;i++){ 
			for (j=0;j<3;j++) {
				normala[j]=modelToload->modelVertices[v];
				v++;
			}
			for (j=0;j<3;j++) {
				normalb[j]=modelToload->modelVertices[v];
				v++;
			}
			for (j=0;j<3;j++) {
				normalc[j]=modelToload->modelVertices[v];
				v++;
			}
	
			ab[0]=normalb[0]-normala[0]; ab[1]=normalb[1]-normala[1]; ab[2]=normalb[2]-normala[2];
			ac[0]=normalc[0]-normala[0]; ac[1]=normalc[1]-normala[1]; ac[2]=normalc[2]-normala[2];
			dst[0]=ab[1]*ac[2] - ab[2]*ac[1];
			dst[1]=ab[2]*ac[0] - ab[0]*ac[2];
			dst[2]=ab[0]*ac[1] - ab[1]*ac[0];
			len=(float) sqrt((double)( dst[0]*dst[0]+dst[1]*dst[1]+dst[2]*dst[2] ) );
			//len= sqrt( dst[0]*dst[0]+dst[1]*dst[1]+dst[2]*dst[2] ) ;
			for(j=0;j<3;j++) { //load the 3 calculated normals for each vertice (3)
				//later will share normals between vertices of different faces for
				//smooth shading
				modelToload->face_normals[n]=dst[j]/len;
				n++;
			}
			for(j=0;j<3;j++) {
				modelToload->face_normals[n]=dst[j]/len;
				n++;
			}
			for(j=0;j<3;j++) {
				modelToload->face_normals[n]=dst[j]/len;
				n++;
			}
	
		}
	
	}		

	if (filetype[0] == 'j') { // for my own j3d filetype

	//need to create a header for this file
	//maybe start with
	//number of faces
	//etc
	
		
		indices = 0;
		line = 0;	
		f = 0; g = 0, n = 0;
		donothing = 1;
		if (line == 0) {
			fgets(data, sizeof(data), fileptr);
			sscanf(data,"%d %d %s", &startFrame, &endFrame, &objName);			
			modelToload->lastFrame = endFrame;
			modelToload->currframe = 0;
			modelToload->frameTime = SDL_GetTicks();
			strcpy(modelToload->name, objName);
			if ( (endFrame > 1) && (endFrame != 250) ) strcpy(modelToload->type, "anim"); else strcpy(modelToload->type, "static");
			line++;
		}

	
	/*	while (donothing == 0) {
			fgets(data, sizeof(data), fileptr);
			printf("gets here1 %c",data[0]);
			printf("gets here2");
			if (data[0] == 'V') {
				printf("\ngets here");
				sscanf(data,"%s %d",&nullstring, &readinframe);
				if(readinframe == currframe) {
					doing[0] = data[0];
					donothing = 1;
				}
				
			} //if we are reading frame data in a frame less
		}*/

				


  		while( fgets(data, sizeof(data), fileptr) != NULL ) {
			line++;
			//if (data[0] == 'V' || data[0] == 'F' || donothing) {
			if (donothing) {
				if (data[0] == 'V' || data[0] == 'F' ) {
					//printf("\ngets in here line is %d\n",line);
					doing[0] = data[0];
				}else continue;
				if (doing[0] == 'V' ){ //check to see if we are loading the correct frame
						sscanf(data,"%s %d",&nullstring, &readinframe) ;
						//if (readinframe == currframe) donothing = 0; else donothing=1; //if we are reading frame data in a frame less
						if (readinframe == currframe) donothing = 0; else continue; //if we are reading frame data in a frame less
																					  //than the one we want we want to do nothing until
																					  // we get to the frame data we want.
				}else continue;	
		//	line++;
			//continue;
			//}else continue;
			}
			if (data[0] == 'V' || data[0] == 'F' ) {
				//printf("\ngets in here line is %d\n",line);
				doing[0] = data[0];
			}
			//line++;
		//	if ( line < 3 ) { 
		//		line++;
		//		continue;
		//	}
			if(doing[0] == 'V') { //load all the vertices and their normals into a temp array 
				fgets(data, sizeof(data), fileptr);
				sscanf(data,"%d",&noVerts);
				modelToload->NoRawVertices = noVerts; 
				for (i=0 ; i<noVerts ; i++) {
					fgets(data, sizeof(data), fileptr);
					sscanf(data, "%f %f %f %f %f %f", &f1, &f2, &f3, &n1, &n2, &n3);
					f1 *= ScalingFactor;
					f2 *= ScalingFactor;
					f3 *= ScalingFactor;
					tempVerts[vertPos] = f1;
					modelToload->RawVertices[vertPos] = f1;
					vertPos++;
					tempVerts[vertPos] = f2;
					modelToload->RawVertices[vertPos] = f2;
					vertPos++;
					tempVerts[vertPos] = f3;
					modelToload->RawVertices[vertPos] = f3;
					vertPos++;
					tempNorms[n] = n1; n++;
					tempNorms[n] = n2; n++;
					tempNorms[n] = n3; n++;
				}
			}
			vertPos = 0;
			n = 0; nf = 0;
			for (i=0; i < 300; i++) { 
					xdata[i] = NULL;
			}
			fgets(data, sizeof(data), fileptr);
			doing[0] = data[0];
			//skybox op here
			if(doing[0] == 'F') {
				fgets(data, sizeof(data), fileptr);
				sscanf(data,"%d",&noFaces);
				modelToload->vertices = noFaces * 3;

				for(i=0 ; i < noFaces ; i++) {
					fgets(data, sizeof(data), fileptr);
					//texture specific stuff
					for(k = 0 ; k < 300 ; k++) { // extract the texture filename
							if (data[k] == '"') { 
									k++;
									for (j=0 ; data[k] != '"' ; j++ ) {
											textureFilename[j] = data[k];
											k++;
									}
									for (j=j ; j < 30 ;j++) textureFilename[j] =  NULL;
									k = 299; // There should be no " character here so it will jump out of this loop
							}
					}
					for(k = 0 ; k < 300 ; k++) { //get rid of funny characters in the string, this string will be diff if no texture ie NONE [] so [] will be removed and the scan below will get bad data
							data[k] = cleanLoadString( data[k] );
					}
					
					for (j=0 ; j < 30 ; j++) nullstring[j] = NULL; //initialize a couple of variables
					for (j=0 ; j < 6 ; j++) uv[j] = 0;
					sscanf(data,"%d %d %d %d %f %f %f %s %s %f %f %f %f %f %f", &faces, &i1, &i2, &i3, &f1, &f2, &f3, &nullstring, &nullstring2, &uv[0], &uv[1], &uv[2], &uv[3], &uv[4], &uv[5] );			
					if (  ! ( strcmp("None", nullstring) ) || ! ( strcmp("",nullstring) ) ) { //if this is true we have no texture to load
						loadTexture = 0;
						for(j=0 ; j<6 ; j++) {
								modelToload->modelTexcoords[texPos] = 0;
								texPos++;
						}
					} else loadTexture = 1;
					if (loadTexture ) {
							for(j=0 ; j<6 ; j++) {
									modelToload->modelTexcoords[texPos] = uv[j];
									texPos++;
							}

							if (!modelToload->textureLoaded) {
								modelToload->textureIndex = loadTextures (textureFilename, 30);
							}
							loadTexture = 0;
							modelToload->textureLoaded = 1;
					}

					//prolly need to load colors if there is no texture
					
					//end texture specific stuff
					
					if(faces != 3) {
						printf("\nERROR LOADING MODEL!\nNOT A TRI MODEL.");
						break;
					}
					for(j = 0; j < 3; j++) {
						modelToload->modelVertices[vertPos] = tempVerts[(i1*3)+j];
						modelToload->normals[n] = tempNorms[(i1*3)+j]; n++;
						modelToload->colors[vertPos] = 1.0f; //allways textured
						vertPos++;
					}
					for(j = 0; j < 3; j++) {
						modelToload->modelVertices[vertPos] = tempVerts[(i2*3)+j];
						modelToload->normals[n] = tempNorms[(i2*3)+j]; n++;
						modelToload->colors[vertPos] = 1.0f; //allways textured
						vertPos++;
					}
					for(j = 0; j < 3; j++) {
						modelToload->modelVertices[vertPos] = tempVerts[(i3*3)+j];
						modelToload->normals[n] = tempNorms[(i3*3)+j]; n++;
						modelToload->colors[vertPos] = 1.0f; //allways textured
						vertPos++;
					}
					for (g = 0; g < 3; g++) {
						modelToload->face_normals[nf] = f1; nf++;
						modelToload->face_normals[nf] = f2; nf++;
						modelToload->face_normals[nf] = f3; nf++;
					}
					


				}
				for (j = 0; j < (noFaces*3); j++)  {
					modelToload->indices[j]=j; //add indicies, for how many triangles there are
				}
			}
			

			
		currframe++;
		//printf("\nlastframe = %d\n",modelToload->lastFrame);
		if (currframe > modelToload->lastFrame) {
				currframe = 1;
				readinframe = 0;
				return 0;
		}
		else { 
				return 1;
		}
		}
		
		
	}

    return 0;
}


/*int loadModelTextures ( char texturename ) {

	use IMG_Load("name");

}*/



int detectCollision( int *model1, int *model2 ) {

	model *character, *object2;
	GLfloat d_sqd, faceNormalVector[3], collideeVertice[3], colliderVertice[3], vectorCC[3];
	GLfloat CollideeX, CollideeY, CollideeZ, ColliderX, ColliderY, ColliderZ, dst, e, f, g, dotP;
	int checkFurther = 0, i, j, k,  object2faces = 0, characterVerts = 0,  characterFaces, hitPlus = 0, hitMinus = 0, hit = 0;
	
	character = model1;
	object2 = model2;
	object2faces = object2->vertices / 3; //number of faces in the collidee object
	characterFaces = character->vertices;
	GLfloat m[16], charx, chary, charz, objx, objy, objz;
	d_sqd = sq(object2->CentrePos[0] - character->CentrePos[0]) + sq(object2->CentrePos[1] - character->CentrePos[1]) + sq(object2->CentrePos[2] - character->CentrePos[2]);
	if ( d_sqd < sq(character->radius + object2->radius) ) {
		checkFurther = 1; //We have collided the two spheres, now check if a vertice has penetrated a face
	}
	else return 0;
	if (checkFurther) {
			checkFurther = 0;
			for (i = 0 ; i < object2faces && !hit ; i++ ) {
					faceNormalVector[0] = object2->face_normals[(i*3)*3+0];
					faceNormalVector[1] = object2->face_normals[(i*3)*3+1];
					faceNormalVector[2] = object2->face_normals[(i*3)*3+2]; //now we have the face normals of the object
					//has 3 sets of face vertices in the array, 1 for each vertice I guess as shown in the output
					//Get a vertice on the face
					CollideeX = object2->modelVertices[(i*3)*3+0];//get vertices for one point on this face
					CollideeY = object2->modelVertices[(i*3)*3+1];
					CollideeZ = object2->modelVertices[(i*3)*3+2];
					
					hitPlus = 0; hitMinus = 0;	//Reset these for the next test
					//find which faces lie in front of the model, as the other faces will allways test that we are penetrating	
					for (j = 0 ; j < character->NoRawVertices && !hit ; j++) {	//check all model verts to see which one collided with the Collidee face
					
							//add new variable to typedef for the matrix stack, then grab the stack at the point after we rotate it in scene.c
							//and store it in the new variable, then use that stack to retrieve the new coordinates for the test below
							
							//we need to test all vertices of the model against this face.
							charx = character->RawVertices[j*3+0];
							chary = character->RawVertices[j*3+1];
							charz = character->RawVertices[j*3+2];
							ColliderX = charx*character->matrix[0] + chary*character->matrix[4] + charz*character->matrix[8] + 1*character->matrix[12];
							ColliderY = charx*character->matrix[1] + chary*character->matrix[5] + charz*character->matrix[9] + 1*character->matrix[13];
							ColliderZ = charx*character->matrix[2] + chary*character->matrix[6] + charz*character->matrix[10] + 1*character->matrix[14];
							
							dst = sqrt(sq(ColliderX-CollideeX) + sq(ColliderY-CollideeY) + sq(ColliderZ-CollideeZ)); //distance between a coordinate on the
							//object face and character vertice being tested
							e = (ColliderX - CollideeX) /dst;
							f = (ColliderY - CollideeY) /dst;
							g = (ColliderZ - CollideeZ) /dst;

							//Now we have the vector efg and the Face normal vector, dot these and if result is negative the characters vertice has
							//penetrated the face of the object
					
							dotP = ( faceNormalVector[0] * e ) + ( faceNormalVector[1] * f ) + ( faceNormalVector[2] * g );

							if(dotP < 0) {
									hitMinus = 1;
									//i = object2faces; //break out
							}
							if(dotP > 0) {
									hitPlus = 1;
									//i = object2faces; //break out
							}
							if (hitPlus && hitMinus) { 
									hit = 1;
							}
							if (hit) character->Cface_normal_pos = i; 
							

					}
			}
			return hit;

	}
}

void terrainDetection( int *character, int *land, int *cameray) {

	model *character_model, *land_model;
	GLfloat d1, d2, d3, x1, y1, z1, x2, y2, z2, e1, f1, g1, e2, f2, g2, e3, f3, g3 ;
	static GLfloat y = 0.0f;
	GLfloat d,D, xx,yy,zz, A, B, C;
	double dp1, dp2, dp3;
	int i,ap;
	float *camerayy;
	camerayy = cameray;
	character_model = character;
	land_model = land;

	//you need the characters face normals for this code to work it should get loaded into the models face_normals member
	x1 = character_model->pos[0];
	y1 = 0.0f;
	//y1 = character_model->pos[1];
	z1 = character_model->pos[2];
	// Find on which plane the character is standing.
	for(i=0 ; i< land_model->vertices ; i++) {
		//first vector
		x2 = land_model->modelVertices[i*3];
		y2 = 0.0f;
		//y2 = land_model->modelVertices[i*3+1];
		z2 = land_model->modelVertices[i*3+2];
		//find the distance between the 2 coordinates
		d1 = sqrt(sq(x2-x1) + sq(y2-y1) + sq(z2-z1));
		//find the vector between these 2 points
		e1 = (x2 - x1) / d1;
		f1 = (y2 - y1) / d1;
		g1 = (z2 - z1) / d1;

		//do the same for the next two. 
		
		i++;
		//first vector
		x2 = land_model->modelVertices[i*3];
		y2 = 0.0f;
		//y2 = land_model->modelVertices[i*3+1];
		z2 = land_model->modelVertices[i*3+2];
		//find the distance between the 2 coordinates
		d2 = sqrt(sq(x2-x1) + sq(y2-y1) + sq(z2-z1));
		//find the vector between these 2 points
		e2 = (x2 - x1) / d2;
		f2 = (y2 - y1) / d2;
		g2 = (z2 - z1) / d2;

		i++;
		//first vector
		x2 = land_model->modelVertices[i*3];
		y2 = 0.0f;
		//y2 = land_model->modelVertices[i*3+1];
		z2 = land_model->modelVertices[i*3+2];
		//find the distance between the 2 coordinates
		d3 = sqrt(sq(x2-x1) + sq(y2-y1) + sq(z2-z1));
		//find the vector between these 2 points
		e3 = (x2 - x1) / d3;
		f3 = (y2 - y1) / d3;
		g3 = (z2 - z1) / d3;

		//now work out the angle between the vectors, if ~360 then we are on this plane
		dp1 = (e1 * e3) + (f1 * f3) + (g1 * g3);
		dp1 = acos(dp1)* ( 180 / PI);
		dp2 = (e3 * e2) + (f3 * f2) + (g3 * g2);
		dp2 = acos(dp2) * ( 180 / PI);
		dp3 = (e2 * e1) + (f2 * f1) + (g2 * g1);
		dp3 = acos(dp3) * ( 180 / PI);

		if ((dp1 + dp2 + dp3) > 359.9f) { //We've found the triangle where we are sitting
			ap = i-2;	
			xx = x2;yy = land_model->modelVertices[i*3+1];zz = z2;
			A = land_model->face_normals[ap*3];B = land_model->face_normals[ap*3+1];C = land_model->face_normals[ap*3+2];
		}
		
	}

	D = -(A*xx + B*yy + C*zz);
	d =  (A * xx + B * yy + C * zz + D); //d should be zero
	y =  -  ( ( A * character_model->pos[0] + C * character_model->pos[2] ) +D ) / B;
	character_model->pos[1] = y ;
	*camerayy = -(character_model->pos[1] + 2.0f); //position the camera a little above the character
}

char cleanLoadString( char toChange ) {
		
	switch(toChange){

		case '[':
				return ' ';
		case ']':
				return ' ';
		case '(':
				return ' ';
		case ')':
				return ' ';
		case ',':
				return ' ';

		default:
				return toChange;

	}

}
