#include "game.h"

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


int handle_key_down( SDL_keysym* keysym, int whatToDo ) {

    static keymap keys;
    static int loop=0;
    SDL_Event gevent;
    if(whatToDo) {
        while(loop!=7){
            if(SDL_WaitEvent(&gevent)){
                switch( gevent.type ) {
                    case SDL_KEYDOWN:
                    //ownkeysym[loop]=gevent.key.keysym.sym;
                    //loop++;
                    switch(loop) {
                        case 0:
                        keys.sleft=gevent.key.keysym.sym;
                        break;
                        case 1:
                        keys.sright=gevent.key.keysym.sym;
                        break;
                        case 2:
                        keys.frwrd=gevent.key.keysym.sym;
                        break;
                        case 3:
                        keys.bckwrd=gevent.key.keysym.sym;
                        break;
						case 4:
						keys.camup=gevent.key.keysym.sym;
						break;
						case 5:
						keys.camdwn=gevent.key.keysym.sym;
						break;
						case 6:
						keys.jump=gevent.key.keysym.sym;
						break;
                        default:
                        break;
                    }
                    loop++;
                    if (loop==7) {
                        loop=0;
                        return GAME; //if finished setting up the keys, start game
                    }
                    else return MENU;
                }
            }
        }
    }  else {
        if(keysym->sym==keys.frwrd) return 4; //move forwards
        if(keysym->sym==keys.bckwrd) return 3; //move backwards
        if(keysym->sym==keys.sright) return 5; //strafe right
        if(keysym->sym==keys.sleft) return 6; //strafe left
        if(keysym->sym==keys.jump) return 9; //jump
		if(keysym->sym==keys.camup) return 7; //move camera up
		if(keysym->sym==keys.camdwn) return 8; //move camera down
        if(keysym->sym==SDLK_ESCAPE){
            h3dexit( 0 );
        }
    }
	return 0;
}

int handle_mousemotion( SDL_MouseMotionEvent *motion, int wtd , int *zzmove) {

    int move;
    int whichWay=-1;
    cmMov *hmmzzmove=zzmove;
    // find if look left or right
    if(!wtd) {
        if(!motion->xrel) {
            return 0;
        }
        else {
            if(motion->xrel<0) whichWay=1; //left
            if(motion->xrel>0) whichWay=0;//right
        }

        //speed of looking, depends on the x and y relative positions

        if(motion->xrel>100 || motion->xrel<-100) hmmzzmove->rspeed=2.0f; //if greater than the cursor is centered
        if(( motion->xrel<0 && motion->xrel>-3) || ( motion->xrel>0 && motion->xrel<3) ) hmmzzmove->rspeed=0.8f;
        else hmmzzmove->rspeed=2.0f;
        if( motion->xrel<-5  ||  motion->xrel>5 )  hmmzzmove->rspeed=5.0f;
        switch (whichWay) {
            case 0 :
            move=2;
            break;
            case 1 :
            move=1;
            break;
            default:
            break;
        }
        if (motion->x >600 || motion->x <50) SDL_WarpMouse(320,240);
        return move;
    }
    if(wtd) {
        if(!motion->yrel) {
            return 0;
        }
        else {
            if(motion->yrel<0) {
                whichWay=1; //up
            }
            else if(motion->yrel>0) whichWay=0;//down
        }
        //look speed for y relative, up and down
        if(motion->yrel>100 || motion->yrel<-100) hmmzzmove->yspeed=2.0f; //if greater than the cursor is centered
        if(( motion->yrel<0 && motion->yrel>-3) || ( motion->yrel>0 && motion->yrel<3) ) hmmzzmove->yspeed=0.8f;
        else hmmzzmove->yspeed=2.0f;
        if( motion->yrel<-5  ||  motion->yrel>5 ) hmmzzmove->yspeed=5.0f;
        switch (whichWay) {
            case 0 :
            //if(motion->yrel<-1) move=2; //so doesn't jump on the screen
            move=2;
            break;
            case 1 :
            //if(motion->yrel>1) move=1;
            move=1;
            break;
            default:
            break;
        }
        if (motion->y >400 || motion->y <50) SDL_WarpMouse(320,240);
        return move;
    }
	return 0;
}

int*  processkeyboard_events( void ) {

    SDL_Event event;
    static cmMov zmove={0,0,0,0,0,0,0,0,0,0,0,0,0};
    int which;
    /* Grab all the events off the queue. */
    while( SDL_PollEvent( &event ) ) {
        switch( event.type ) {
            case SDL_KEYDOWN:
            /* Handle key presses. */
            which=handle_key_down( &event.key.keysym, 0 );
            switch (which) {
                case 3: //down
                zmove.backward=1;
                break;
                case 4: //up
                zmove.forward=1;
                break;
                case 5:	//right
                zmove.strafeRight=1;
                break;
                case 6: //left
                zmove.strafeLeft=1;
                break;
				case 7: //camera up;
				zmove.cameraUp=1;
				break;
				case 8:
				zmove.cameraDown=1;
				break;
				case 9:
				zmove.jump=1;
				break;
                default:
                break;
            }
            break;
            case SDL_MOUSEMOTION:
            which=handle_mousemotion( &event.motion, 0, &zmove );
            switch( which ) {
                case 2:
                zmove.lookRight=1; //right
                break;
                case 1:
                zmove.lookLeft=1; //left
            }
            //break;
            which=handle_mousemotion( &event.motion, 1, &zmove );
            switch( which ) {
                case 2:
                zmove.lookup=1;
                break;
                case 1:
                zmove.lookdown=1;
            }
            break;
            case SDL_KEYUP:
            which=handle_key_down( &event.key.keysym, 0 );
            switch (which) {
                case 3: //down
                zmove.backward=0;
                break;
                case 4: //up
                zmove.forward=0;
                break;
                case 5:
                zmove.strafeRight=0;
                break;
                case 6:
                zmove.strafeLeft=0;
                break;
				case 7:
				zmove.cameraUp=0;
				break;
				case 8:
				zmove.cameraDown=0;
				break;
				case 9:
				zmove.jump=0;
				break;
                default:
                break;
            }
            break;
            case SDL_QUIT:
            /* Handle quit requests . */
            h3dexit( 0 );
            break;
        }
    }

    return &zmove;
}
