
//physics.c
//Arek Stankiewicz
//physics code for Hugooski3D

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include "game.h"
void reactToHit( int *model1, int *model2, int *Msg)  {

	model 		*character, *object;
	Messages	*SendMsg;
	int 		i;

	GLfloat 		a[3], b[3], c[3], t[3], n[3], dist, ndota, cposx, cposy, cposz, prevposx, prevposy, prevposz;
	character 	= model1;
	object 		= model2;
	SendMsg		= Msg;
	i			= character->Cface_normal_pos;
	if ( !strcmp(object->name, "Wall")) { //returns 0 if the two strings are equal
		//do wall sliding code
		//a will be the characters velocity vector
		//b will be the walls velocity vector (the force the wall gives in response to a
		//c will be the vector along which the character slides
		printf("\n\nAA character prevpos is %f, %f, %f",character->prevpos[0], character->prevpos[1], character->prevpos[2]);
		printf("\nAA character pos is %f, %f, %f",character->pos[0], character->pos[1], character->pos[2]);
		
		//The below if is to detect if model coordinates have changed, if not then no point doing this test and can get nan numbers
		if ( ( character->pos[0] != character->prevpos[0] ) || ( character->pos[1] != character->prevpos[1] ) || ( character->pos[2] != character->prevpos[2] ) ) {
			t[0] = character->pos[0] - character->prevpos[0]; //get the distance between the characters current position and the previous position
			t[1] = character->pos[1] - character->prevpos[1];	
			t[2] = character->pos[2] - character->prevpos[2];
			dist = sqrt (t[0] * t[0] + t[1] * t[1] + t[2] * t[2]);
			
			//a[0] = ( character->pos[0] / dist ) - character->prevpos[0]; //get the characters velovity vector
			//a[1] = ( character->pos[1] / dist ) - character->prevpos[1];
			//a[2] = ( character->pos[2] / dist ) - character->prevpos[2];
			a[0] = ( character->pos[0] - character->prevpos[0] ) / dist ; //get the characters velovity vector
			a[1] = ( character->pos[1] - character->prevpos[1] ) / dist ; 
			a[2] = ( character->pos[2] - character->prevpos[2] ) / dist ;
	
			n[0] = object->face_normals[(i*3)*3+0]; //get the normal of the walls face
			n[1] = object->face_normals[(i*3)*3+1];
			n[2] = object->face_normals[(i*3)*3+2];

			//b = n * (n dot a)
			//c = a-b
			ndota = n[0] * a[0] + n[1] * a[1] + n[2] + a[2];
			if (ndota > 0) ndota *= -1; //allways negative so reacts opposite to the normal vector (moves away from the wall)
			
			b[0] = ndota * n[0];
			b[1] = ndota * n[1];
			b[2] = ndota * n[2];

			c[0] = a[0] - b[0];
			c[1] = a[1] - b[1];
			c[2] = a[2] - b[2];

			printf("\n\ncharacter prevpos is %f, %f, %f",character->prevpos[0], character->prevpos[1], character->prevpos[2]);
			printf("\ncharacter pos is %f, %f, %f",character->pos[0], character->pos[1], character->pos[2]);
			cposx = character->pos[0];
			printf("\nn id %f, %f, %f",n[0], n[1], n[2]);
			printf("\na is %f, %f, %f, ndota is %f, dist is %f", a[0], a[1], a[2], ndota, dist);
			printf("\nb is %f, %f, %f",b[0], b[1], b[2]);
			printf("\nc is %f, %f, %f",c[0], c[1], c[2]);
			//character[0].pos[0]=character[0].prevpos[0]; //hit something so go back to previous position
			//character[0].pos[2]=character[0].prevpos[2];
			//
			//
			//check scene.c as this sort of works now, but stil walks into the wall if facing it too strongly.
			//may be that in scene.c the characters position needs to be loaded again after this test (it is loaded previously)
			//this may also get rid of the jerkiness
			//
			//
			prevposx = character->pos[0];
			prevposz = character->pos[2];

			character->pos[0] = c[0] * 0.01 + character->prevpos[0]; 
			character->pos[2] = c[2] * 0.01 + character->prevpos[2];
			
			character->prevpos[0] = prevposx;
			character->prevpos[2] = prevposz;
				
			printf("\nNEW character pos is %f, %f, %f",character->pos[0], character->pos[1], character->pos[2]);
			SendMsg->ModelCollided = 1;
			SendMsg->cx = character->pos[0];
			SendMsg->cy = character->pos[1];
			SendMsg->cz = character->pos[2];
			//printf("position is %d\n",character->Cface_normal_pos);

		}

	} else { //for now to test the above code, later remove this else and add other ifs or a switch
		printf("\n\nIS OK\n");
		//character->pos[0]=character->prevpos[0]; //hit something so go back to previous position
		//character->pos[2]=character->prevpos[2];
		//SendMessage->ModelCollided = 1;

	}
	

}
