/* scene.c
 * Arek Stankiewicz
 * renders the scene
 */

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include "game.h"

int* drawScene2(GLfloat cameraPosX, GLfloat cameraPosY, GLfloat cameraPosZ, int rotateChar, int DoRotateChar, GLfloat yrot, int *cameray, int jump ) {
    
    static model box1, character[41], wall, level1ground, sphere; 
	static animmodel animmodels[20]; //40 animated models with 40 frames each
    static int loadModels=1, frame=1, count=10, currframe, terrainPos, JumpUp=0, JumpDown=0;
    static int settoneutral = 0, HitSomething = 0,  modelFrameLoad=1, modelsInScene;
	static Uint32 thisframe, lastframe, deltaframe;
    int i, fileline;
	int b;
    //load all these values into the box1 structure
    static float rspeed= 0.004f, StartJump = 0.0f, MaxJumpHeight = 0.2f, ScalingFactor = 1.0f;
    static float characterAngle=0.0f, characterRot=0.0f, currentPosX=0.0f, currentPosY=0.0f, currentPosZ=0.0f;
	GLfloat *camerayy = cameray;
    char filenam[30], worldfilename[17]="data/world.jen", filedata[100]; //could be level dependant
	char modeltype[20];
    FILE *fileptr;
    static float chrrot=0.0f;
	static Messages	SendMessage;
    //draw a basic floor
    glEnable( GL_TEXTURE_2D );
/*    glPushMatrix();
    glTranslatef(0.0f, 0.0f, 0.0f);
    //rotation

    glBindTexture ( GL_TEXTURE_2D, 1 ) ; //just a quick hack for a sky
    glBegin(GL_QUADS);
    glColor3f( 0.05f, 0.0f, 1.5f );
    glTexCoord2f(0.0f,1.0f); glVertex3f( -5000.0f, 200.0f, -5000.0f);
    glTexCoord2f(0.0f,0.0f); glVertex3f(5000.0f, 200.0f, -5000.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(5000.0f, 200.0f, 5000.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f( -5000.0f, 200.0f, 5000.0f);
    glEnd();

    glPopMatrix();*/

    //load the models
    if (loadModels){
        //insert indices values
        for (i=0;i<NUM_FACE_VERTICES;i++) {
//            box1.indices[i]=NULL;
            character[0].indices[i]=NULL;
//    	level1ground.indices[i]=NULL;
        }
		for (i=0;i < 3*NUM_FACE_VERTICES ; i++ ) {
				character[0].colors[i] = 1.0f;
		}
		//Initial Position of the Character
	 	terrainDetection(&character[0], &animmodels[terrainPos].frame[0], cameray);
    	character[0].pos[0]=cameraPosX; //have to invert because the cameras translation is inverted to the models
    	character[0].pos[2]=cameraPosZ;
		//End of initial position of character



	fileptr=fopen(worldfilename , "r");
	if( fileptr == NULL) {
			printf("\nERROR world file %s does not exist.\n",worldfilename);
	}
	modelsInScene = 0; // the model array position is set to zero
	fileline = 1; //start loading models from our world file
	while ( fgets(filedata, sizeof(filedata), fileptr) != NULL) {
			if ( fileline < 4 ) { //first 4 lines contain no useable data
				fileline++;
				continue;
			}
			sscanf(filedata,"%s",&modeltype);
			fgets(filedata, sizeof(filedata), fileptr);	//grab the filename
			ScalingFactor = 1.0f; //Set to 1 just incase forgot to set in the world.jen file, otherwise model will not show
			if (! (strcmp("terrain", modeltype)) ) { //load a generic model
				i = 0;
				b = i;
				//printf("\n%d is i\n",i);
				modelFrameLoad = 1;
				//printf("\n%d is i01\n",i);
				sscanf(filedata,"%s %f",&filenam, &ScalingFactor);
				//i = 0;
				//printf("\n%d b,  %d i,  %d filenam\n",&b,&i,&filenam);
				//printf("\n%s filename00000\n",filenam);
				//printf("\n%d is i1\n",i);
				//printf("\n%d is b1\n",b);
				terrainPos = modelsInScene;
				//printf("\n%d is i2\n",i);
				if(!i) {
					animmodels[modelsInScene].frame[i].textureLoaded = 0; //to only load one occurrence of the texture
					//printf("\n%s filename22222\n",filenam);
					strcpy(animmodels[modelsInScene].frame[i].filename,filenam);
					//printf("\n%s filename1\n",filenam);
				}
				else animmodels[modelsInScene].frame[i].textureLoaded = 1;
				while(modelFrameLoad) {
					if(i > 0) animmodels[modelsInScene].frame[i].textureLoaded = 1;	
					modelFrameLoad = loadModel(&animmodels[modelsInScene].frame[i], filenam, ScalingFactor);
					
					i++;
					if (i > 40) { //display a warning if models has greater than the allowable frames
							printf("\n %s has exceeded %d frames and may not show correctly\n",filenam, i-1);;
					}
				}
				fgets(filedata,sizeof(filedata), fileptr); //grab the initial position
				sscanf(filedata,"%f %f %f %f %f %f", &animmodels[modelsInScene].frame[0].pos[0], &animmodels[modelsInScene].frame[0].pos[1], &animmodels[modelsInScene].frame[0].pos[2], &animmodels[modelsInScene].frame[0].rot[0] ,&animmodels[modelsInScene].frame[0].rot[1], &animmodels[modelsInScene].frame[0].rot[2]);
			}
			
			if (! (strcmp("hero", modeltype )) ) { //load into character array as this is the main character
				i = 0;
				modelFrameLoad = 1;
				sscanf(filedata,"%s %f",&filenam, &ScalingFactor);
				printf("\n%f SF\n",ScalingFactor);
				if(!i) { 
					
					character[i].textureLoaded = 0; //to only load one occurrence of the texture
					strcpy(character[i].filename,filenam);
				}
				else character[i].textureLoaded = 1;
				while(modelFrameLoad) {
					if(i > 0) character[i].textureLoaded = 1;	
					modelFrameLoad=loadModel(&character[i], filenam, ScalingFactor);
					i++;
				}
				i = 0;
				fgets(filedata,sizeof(filedata), fileptr); //grab the initial position
															//this is set to 000 as it is relative to the camera pos
				sscanf(filedata,"%f %f %f", &character[0].pos[0], &character[0].pos[1], &character[0].pos[2]);
				//continue; //grab the next section of data
				modelsInScene--; // This is not included in the animmodels array, it is in the character array

			}
			if (! (strcmp("scene", modeltype)) ) { //load a generic model
				i = 0;
				modelFrameLoad = 1;
				sscanf(filedata,"%s %f",&filenam, &ScalingFactor);
				if(!i) { 
					animmodels[modelsInScene].frame[i].textureLoaded = 0; //to only load one occurrence of the texture
					animmodels[modelsInScene].frame[i].hit = 0;
					strcpy(animmodels[modelsInScene].frame[i].filename,filenam);

				}
				else animmodels[modelsInScene].frame[i].textureLoaded = 1;
				i = 0;
				while(modelFrameLoad) {
					if(i > 0) animmodels[modelsInScene].frame[i].textureLoaded = 1;	
					modelFrameLoad = loadModel(&animmodels[modelsInScene].frame[i], filenam, ScalingFactor);
					i++;
					if (i > 40) { //display a warning if models has greater than the allowable frames
							printf("\n %s has exceeded %d frames and may not show correctly\n",filenam, i-1);;
					}
				}
				fgets(filedata,sizeof(filedata), fileptr); //grab the initial position
				sscanf(filedata,"%f %f %f %f %f %f", &animmodels[modelsInScene].frame[0].pos[0], &animmodels[modelsInScene].frame[0].pos[1], &animmodels[modelsInScene].frame[0].pos[2], &animmodels[modelsInScene].frame[0].rot[0] ,&animmodels[modelsInScene].frame[0].rot[1], &animmodels[modelsInScene].frame[0].rot[2]);
			}
			modelsInScene++; //Will allways be one more
			
			//printf("\n%s\n",animmodels[0].frame[0].name); //show name of model as set in blender
	} // End of while fgets
	//End of loading models
	for (i = 0 ; i < modelsInScene ; i++ ) {

		//only shows scene models, not hero, hero is loaded into &character
        	calculateExtremities(&animmodels[i].frame[0]);
		//it would be good to show the model name below, or filename loaded from for debug in future
        	printf(" Model %d, lower: %lf, upper: %lf\n", i, animmodels[i].frame[0].extremx[0], animmodels[i].frame[0].extremx[1]);
        	printf(" Model %d, lower: %lf, upper: %lf\n", i, animmodels[i].frame[0].extremy[0], animmodels[i].frame[0].extremy[1]);
        	printf(" Model %d, lower: %lf, upper: %lf\n", i, animmodels[i].frame[0].extremz[0], animmodels[i].frame[0].extremz[1]);
			printf(" Model radius %lf\n",animmodels[i].frame[0].radius);
		printf(" Model type is %s\n",animmodels[i].frame[0].type);
		printf(" Model filename is %s\n",animmodels[i].frame[0].filename);
		if (i) {
				printf("\n %f %f %f\n",animmodels[i].frame[0].modelVertices[0],animmodels[i].frame[0].modelVertices[3],animmodels[i].frame[0].modelVertices[6]);
		}
	}
       	calculateExtremities(&character[0]); //calc extremes, radius and centre of character model

	
        loadModels=0;
        
        glClearColor( 0.00f, 0.0f, 0.25f, 0.0f ); //empty world color (background)
		thisframe = SDL_GetTicks();
		lastframe = thisframe;
    }

    //END loading of the models

    //world character rendering
     
    
    


   /* if (!hit) { // !!!!!!!!add this collision detection to the normal drawing loop!!!!!!!!
    	glColorPointer (3, GL_FLOAT, 0, box1.colors);
   	 	glTexCoordPointer (2, GL_FLOAT, 0, box1.modelTexcoords);
	    glNormalPointer ( GL_FLOAT, 0, box1.face_normals);
   	 	glVertexPointer ( 3, GL_FLOAT, 0, box1.modelVertices);

   	 	glBindTexture ( GL_TEXTURE_2D, 3 ) ;
   	 	glPushMatrix();
   		//position the sphere
    
   	 	glTranslatef(box1.pos[0],box1.pos[1],box1.pos[2]);
   	 	chrrot+=rspeed;
   	 	glRotatef(chrrot, 0.5f, 1.0f, 0.0f); 
   	 	//glDrawElements (GL_TRIANGLES, NUM_FACE_VERTICES, GL_UNSIGNED_SHORT, box1.indices); //change NUM_VERTSMODELS to NUM_FACES*3 for 3 vertices in each face
   	 	glPopMatrix();
    }*/
	
	//Draw Models here, add rotating code
	for(i = 0; i < modelsInScene; i++) {
		if (animmodels[i].frame[0].lastFrame == 1) currframe = 0;
		else currframe = animmodels[i].frame[0].currframe;

 		glColorPointer (3, GL_FLOAT, 0, animmodels[i].frame[0].colors); //allways white
    	glTexCoordPointer (2, GL_FLOAT, 0, animmodels[i].frame[0].modelTexcoords);
    	glNormalPointer ( GL_FLOAT, 0, animmodels[i].frame[currframe].normals);
    	glVertexPointer ( 3, GL_FLOAT, 0, animmodels[i].frame[currframe].modelVertices);
    	glBindTexture ( GL_TEXTURE_2D, animmodels[i].frame[0].textureIndex ) ;

    	if(i != terrainPos) glPushMatrix(); //terrain is the parent
    	glTranslatef(animmodels[i].frame[0].pos[0],animmodels[i].frame[0].pos[1],animmodels[i].frame[0].pos[2]);
    	//chrrot+=rspeed;
    	//glRotatef(chrrot, 1.0f, 0.0f, 0.0f); 
		glRotatef(animmodels[i].frame[0].rot[0], 1.0f, 0.0f, 0.0f);
		glRotatef(animmodels[i].frame[0].rot[1], 0.0f, 1.0f, 0.0f);
		glRotatef(animmodels[i].frame[0].rot[2], 0.0f, 0.0f, 1.0f);
    	glDrawElements (GL_TRIANGLES, NUM_FACE_VERTICES, GL_UNSIGNED_SHORT, animmodels[i].frame[0].indices); //change NUM_VERTSMODELS to NUM_FACES*3 for 3 vertices in each face
		if( i != terrainPos ) glPopMatrix();
		thisframe = SDL_GetTicks();
		deltaframe = thisframe - animmodels[i].frame[0].frameTime;
		if (deltaframe > 20) { //the higher this number the slower the model moves
				animmodels[i].frame[0].currframe++; //ADD TIMING
				animmodels[i].frame[0].frameTime = thisframe;
		}
			
			
		if (animmodels[i].frame[0].currframe >= animmodels[i].frame[0].lastFrame) animmodels[i].frame[0].currframe = 0;
	}
            
	//Hugooski drawing
			
	terrainDetection(&character[0], &animmodels[terrainPos].frame[0], cameray);
	if (!character[0].jumping && jump) {
			character[0].jumping=1;
			character[0].JumpingYPos = character[0].pos[1];
			SendMessage.CameraJumpingYPos = *camerayy;
			SendMessage.Jumping = 1;
	}
	if (character[0].jumping){
			if(StartJump >= MaxJumpHeight && !JumpDown) {
					JumpDown = 1;
					JumpUp = 0;
			}else if(!JumpDown) {
					JumpUp = 1;
					JumpDown = 0;
			}

			if(JumpUp) {
					character[0].JumpingYPos += rspeed;
					SendMessage.CameraJumpingYPos -= rspeed;
					StartJump += rspeed;
			} else {
					character[0].JumpingYPos -= rspeed;
					SendMessage.CameraJumpingYPos += rspeed;
					StartJump -= rspeed;
			}

			if(character[0].JumpingYPos <= character[0].pos[1]) {
					character[0].jumping = 0;
					SendMessage.Jumping = 0;
					JumpUp = 0;
					JumpDown = 0;
					StartJump = 0.0f;
			}
			
			
	
	
	}
    if (!count) {
        //if (frame==40) frame=0;
        //else frame++;
        count=10;
    }
        glColorPointer (3, GL_FLOAT, 0, character[0].colors);
        glTexCoordPointer (2, GL_FLOAT, 0, character[0].modelTexcoords);
        glNormalPointer ( GL_FLOAT, 0, character[frame].normals);
        glVertexPointer ( 3, GL_FLOAT, 0, character[frame].modelVertices);
    	glBindTexture ( GL_TEXTURE_2D, character[0].textureIndex ) ;

    count--;
	printf("\npp0 if %f, pp1 is %f, pp2 is %f",character[0].prevpos[0],character[0].prevpos[1],character[0].prevpos[2]);
    if( (character[0].prevpos[0] != character[0].pos[0]) || (character[0].prevpos[1] != character[0].pos[1]) || (character[0].prevpos[2] != character[0].pos[2]) ){
		printf("\ngets in\n");		
		character[0].prevpos[0] = character[0].pos[0];
		character[0].prevpos[1] = character[0].pos[1];
		character[0].prevpos[2] = character[0].pos[2];

	}
	printf("\n cposx = %f, cposz = %f",cameraPosX, cameraPosZ);
    //position the character
    character[0].pos[0]=cameraPosX; //have to invert because the cameras translation is inverted to the models
    character[0].pos[2]=cameraPosZ;
	character[0].CentrePos[0]=cameraPosX;
	character[0].CentrePos[2]=cameraPosZ;
	character[0].CentrePos[1]=character[0].pos[1] + ( ( character[0].extremy[1] - character[0].extremy[0] ) / 2 ); //y pos is the lowest, so we move up to the middle, maybe an issue if it is negative (seg faule divide by zero)
	//printf("\nOld pos x is %f, New Pos x is %f",character[0].prevpos[0] , character[0].pos[0]);	
	//Check to see if we hit another model
	SendMessage.ModelCollided = 0;
	HitSomething = 0;
	for(i = 0 ;  i < modelsInScene ; i++ ) {
		animmodels[i].frame[0].hit = 0;		
	 	if (i != terrainPos) {
				animmodels[i].frame[0].hit = detectCollision(&character[0], &animmodels[i].frame[0]);
		}
		if (animmodels[i].frame[0].hit ) { 
				//HitSomething = 1;
				//character[0].pos[0]=character[0].prevpos[0]; //hit something so go back to previous position
				//character[0].pos[2]=character[0].prevpos[2];
				//SendMessage.ModelCollided = 1; //send message that we have collided
				reactToHit(&character[0], &animmodels[i].frame[0], &SendMessage);
				
		} 
		//we hit something so set HitSomething = 1
		//later when doing the position of character
		//if hit something, loop through till we find the one we hit
		//then interact with it, calc the vector of current pos and prev pos
		//move character away from object until there is no hit.
		//If we strafe we may use the previous vector as we may not want to move back
		//to the position we strafed from but actually away from the object as before.
		
	}


	
    if( (currentPosX != character[0].pos[0]) || (currentPosY != character[0].pos[1]) || (currentPosZ != character[0].pos[2]) ){
	    settoneutral = 0;
	    if (!count) frame++;
            if (frame == character[0].lastFrame) frame=0; // >= because we might have 21 frames but array starts from 0
	    currentPosX = character[0].pos[0];
	    currentPosY = character[0].pos[1];
	    currentPosZ = character[0].pos[2];
	    
    }
    else {
	    if( !settoneutral ) settoneutral = 1;
    }
    if(settoneutral) { //put the character back to standing position if not moving
	  /*  if (frame > 0 && frame < 12 && !count) { 
		    frame--;
		    if (!frame) settoneutral = 0;
	    }
	    if (frame > 11 && frame < 22 && !count) {
		    frame++;
		    if (frame == 21) settoneutral = 0;
	    }
	    if (frame > 21 && frame < 31 && !count) {
		    frame--;
		    if (frame == 21) settoneutral = 0;
	    }
	    if (frame > 31 && frame < 41 && !count) {
		    frame++;
		    if (frame >= 40) {
			    settoneutral = 0;
			    frame = 1;
		    }
	    }*/
    }

    glPushMatrix();
    if(rotateChar) characterRot=yrot; //so we can look around the character, and rotate it when we strafe or move backward or forward
    if(DoRotateChar) {
        if (characterAngle!=characterRot ) characterAngle=characterRot;
    }

	glLoadIdentity(); //we do a preliminary rotate and translate on the identity matrix so we can later use this matrix to get the world coordinates of the model
	if(character[0].jumping) {
			
    		glTranslatef(character[0].pos[0], character[0].JumpingYPos, character[0].pos[2]);

	}else glTranslatef(character[0].pos[0], character[0].pos[1], character[0].pos[2]);
    glRotatef(characterAngle+180.0f, 0.0f, 1.0f, 0.0f);
    glGetFloatv(GL_MODELVIEW_MATRIX,character[0].matrix); //grab the current matrix and store for later collision detection work
														  //this matrix does not include the transformations for the camera
	glPopMatrix();

	glPushMatrix();

	if(character[0].jumping) {
			
    		glTranslatef(character[0].pos[0], character[0].JumpingYPos, character[0].pos[2]);

	}else glTranslatef(character[0].pos[0], character[0].pos[1], character[0].pos[2]);
    glRotatef(characterAngle+180.0f, 0.0f, 1.0f, 0.0f);

    glDrawElements (GL_TRIANGLES, NUM_FACE_VERTICES, GL_UNSIGNED_SHORT, character[0].indices); //change NUM_VERTSMODELS to NUM_FACES*3 for 3 vertices in each face
    glBindTexture ( GL_TEXTURE_2D, 0 ) ;
    glPopMatrix();

//marker code, small red dot below the character

    glPushMatrix();
    //end of character positioning
	glTranslatef(character[0].pos[0], character[0].pos[1], character[0].pos[2]);
    //rotation
    glBegin(GL_QUADS);
    glColor3f (1.0f, 0.0f, 0.0f);
    glVertex3f( -0.02f, 0.0f, 0.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glVertex3f(0.0f, 0.02f, 0.0f);
    glVertex3f( -0.02f, 0.02f, 0.0f);

    glEnd();
    glPopMatrix();

	return &SendMessage;

}
