#include "game.h"

/*Copyright Arek Stankiewicz 2004,2005
 This file is part of Hugooski3D.

 Hugooski3D is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 Hugooski3D is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Hugooski3D; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


//some texture data
unsigned char onetexture [ 16 ] =
{
0x88, 0x70, 0x20, 0xFF,   0x60, 0x88, 0x30, 0xFF,
0x60, 0x88, 0x30, 0xFF,   0x88, 0x70, 0x20, 0xFF
} ;

//a handle for some texture data
//GLuint onetexturehandle[6];
GLuint onetexturehandle;

int loadTextures ( char textureFilename[], int arraySize ) {

    SDL_Surface *TextureImage[2];
    static int done=0, boundTo = 0;
	char path[50] = "data/textures/";
	boundTo++;
	strcat(path,textureFilename);
	TextureImage[1]=IMG_Load(&path);
	//For JPG we can use IMG_Load(path);
	if(TextureImage[1]) {
        glGenTextures ( 1, &onetexturehandle ) ;
        glBindTexture ( GL_TEXTURE_2D, onetexturehandle ) ;
        //gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB, TextureImage[1]->w, TextureImage[1]->h, GL_BGR_EXT,GL_UNSIGNED_BYTE,TextureImage[1]->pixels); //for bmp
        gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB, TextureImage[1]->w, TextureImage[1]->h, GL_RGB,GL_UNSIGNED_BYTE,TextureImage[1]->pixels); //for jpg
        glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR ) ;
        glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR ) ;
        glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP ) ;
        glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP ) ;
        glBindTexture ( GL_TEXTURE_2D, 0 ) ;
        SDL_FreeSurface( TextureImage[1] );
    //}    
    //}
    	done = 1;

		return boundTo;
	}else {
			printf("\nCannot find file %s",path);
	}
	return 0;
}
// have to changea name of offset to xpos, and ypos
void drawtext( char stext[], int stextsize, GLfloat offsetx, GLfloat offsety) {
    //number 1
    int i;	
    GLfloat  ttlx=0.0f, ttly=1.0f, ttrx=0.5f, ttry=1.0f, tblx=0.0f, tbly=0.0f, tbrx=1.0f, tbry=0.0f;
    GLfloat width=0.04f, frb=0.87f, frt=0.84375f,srt=0.625f, widthl=0.0390625f;
    static Uint32 fpsCount, lastfpsCount=0;
    static int frames[3]={0,0,0}, frameCount=0,fc, ii;
    static char displayFrames[3]={'0','0','0'};
    glBindTexture ( GL_TEXTURE_2D, 1 ) ; //bind the fonts		
    glDisable( GL_DEPTH_TEST );
    glPushMatrix();
    glLoadIdentity();
    glTranslatef(0.0f, 0.0f, -5.0f);
    //because we only want how many elements there are
    glEnable( GL_TEXTURE_2D );
    glEnable (GL_BLEND);
    glDisable(GL_DEPTH_TEST);
    stextsize-=1;
    //framecounter
    frameCount++;
    fpsCount=SDL_GetTicks();
    if (fpsCount-lastfpsCount >=1000) {
        //fc=frameCount/(fpsCount/1000);
        fc=frameCount/((fpsCount-lastfpsCount)/1000);
        for(ii=0;ii!=fc;ii++) {
            frames[2]++;
            if (frames[2]==10) {
                frames[2]=0;
                frames[1]++;
                if (frames[1]==10){
                    frames[1]=0;
                    frames[0]++;
                }
            }
        }
        for(i=0;i<3;i++){
            switch(frames[i]) {
                case 0:
                displayFrames[i]='0';
                break;
                case 1:
                displayFrames[i]='1';
                break;
                case 2:
                displayFrames[i]='2';
                break;
                case 3:
                displayFrames[i]='3';
                break;
                case 4:
                displayFrames[i]='4';
                break;
                case 5:
                displayFrames[i]='5';
                break;
                case 6:
                displayFrames[i]='6';
                break;
                case 7:
                displayFrames[i]='7';
                break;
                case 8:
                displayFrames[i]='8';
                break;
                case 9:
                displayFrames[i]='9';
                break;
                default:
                break;
            }
            frames[i]=0;
        }
        lastfpsCount=fpsCount;
        frameCount=0;

    }
    if (stext[0]=='f') {
        stextsize=6;
        stext[3]=' ';
        stext[4]=displayFrames[0];
        stext[5]=displayFrames[1];
        stext[6]=displayFrames[2];
    }
    //end frame counter code

    for (i=0;i<=stextsize;i++) {
        switch (stext[i]) {
            case '0':
            ttlx=0.0f;
            ttly=0.0f;
            ttrx=0.04f;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=0.04f;
            tbry=tbly;
            break;
            case '1':
            ttlx=width;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=ttly;
            tblx=width;
            tbly=1.0f-frb;
            tbrx=tblx+width;
            tbry=1.0f-frb;
            break;
            case '2':
            ttlx=width*2;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=ttly;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '3':
            ttlx=width*3;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=ttly;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '4':
            ttlx=width*4;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '5':
            ttlx=width*5;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '6':
            ttlx=width*6;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '7':
            ttlx=width*7;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '8':
            ttlx=width*8;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case '9':
            ttlx=width*9;
            ttly=0.0f;
            ttrx=ttlx+width;
            ttry=0.0f;
            tblx=ttlx;
            tbly=1.0f-frb;
            tbrx=ttrx;
            tbry=tbly;
            break;
            case 'a':
            ttlx=0.0f;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'b':
            ttlx=widthl;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=widthl;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'c':
            ttlx=widthl*2;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'd':
            ttlx=widthl*3;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'e':
            ttlx=widthl*4;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'f':
            ttlx=widthl*5;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'g':
            ttlx=widthl*6;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;

            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'h':
            ttlx=widthl*7;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'i':
            ttlx=widthl*8;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'j':
            ttlx=widthl*9;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'k':
            ttlx=widthl*10;
            ttly=1.0-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'l':
            ttlx=widthl*11;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'm':
            ttlx=widthl*12;
            ttly=1.0f-frt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'n':
            ttlx=0.0f;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'o':
            ttlx=widthl;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'p':
            ttlx=widthl*2;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'q':
            ttlx=widthl*3;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'r':
            ttlx=widthl*4;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 's':
            ttlx=widthl*5;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 't':
            ttlx=widthl*6;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'u':
            ttlx=widthl*7;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'v':
            ttlx=widthl*8;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'w':
            ttlx=widthl*9;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'x':
            ttlx=widthl*10;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'y':
            ttlx=widthl*11;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case 'z':
            ttlx=widthl*12;
            ttly=1.0f-srt;

            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            case ' ':
            ttlx=widthl*13;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
            default:

            ttlx=widthl*12;
            ttly=1.0f-srt;
            ttrx=ttlx+widthl;
            ttry=ttly;
            tblx=ttlx;
            tbly=ttly+0.21875f;
            tbrx=tblx+widthl;
            tbry=tbly;
            break;
        }
        stext[i]=NULL;
        glBegin(GL_QUADS);
        glColor3f (1.0f, 1.0f, 1.0f);
        // Front Face
        glTexCoord2f(ttlx, tbly); glVertex3f(offsetx, offsety,  1.0f);	// Bottom Left Of The Texture and Quad
        glTexCoord2f(ttrx, tbry); glVertex3f( offsetx+(0.1f), offsety,  1.0f);	// Bottom Right Of The Texture and Quad
        glTexCoord2f(tbrx, ttry); glVertex3f( offsetx+(0.1f),  offsety+(0.1f),  1.0f);	// Top Right Of The Texture and Quad
        glTexCoord2f(tblx, ttly); glVertex3f(offsetx,  offsety+(0.1f),  1.0f);	// Top Left Of The Texture and Qua
        glEnd();
        offsetx+=0.1;	
    }
    glPopMatrix();
    glDisable (GL_BLEND );
    // Turn on the depth buffer
    glEnable( GL_DEPTH_TEST );
    glDisable( GL_TEXTURE_2D );
}
